import{s as Ht,o as _t,n as Mt}from"../chunks/scheduler.c57aa7ef.js";import{S as Ct,i as Rt,g as o,s as n,r as d,A as Pt,h as l,f as a,c as r,j as At,u as h,x as s,k as oe,y as Ft,a as i,v as f,d as u,t as c,w as g}from"../chunks/index.c50cb18e.js";import{T as Ot}from"../chunks/Tip.9268b0ca.js";import{H as w,E as zt}from"../chunks/EditOnGithub.958a8a49.js";function Et(se){let p,T="LoRA is one of the most popular PEFT methods and a good starting point if you’re just getting started with PEFT. It was originally developed for large language models but it is a tremendously popular training method for diffusion models because of its efficiency and effectiveness.";return{c(){p=o("p"),p.textContent=T},l(m){p=l(m,"P",{"data-svelte-h":!0}),s(p)!=="svelte-1gwavmx"&&(p.textContent=T)},m(m,re){i(m,p,re)},p:Mt,d(m){m&&a(p)}}}function jt(se){let p,T,m,re,$,pe,k,Ye="Adapter-based methods add extra trainable parameters after the attention and fully-connected layers of a frozen pretrained model to reduce memory-usage and speed up training. The method varies depending on the adapter, it could simply be an extra added layer or it could be expressing the weight updates ∆W as a low-rank decomposition of the weight matrix. Either way, the adapters are typically small but demonstrate comparable performance to a fully finetuned model and enable training larger models with fewer resources.",me,A,Ze="This guide will give you a brief overview of the adapter methods supported by PEFT (if you’re interested in learning more details about a specific method, take a look at the linked paper).",de,H,he,v,fe,_,Je='As mentioned briefly earlier, <a href="https://hf.co/papers/2106.09685" rel="nofollow">LoRA</a> is a technique that accelerates finetuning large models while consuming less memory.',ue,M,Qe="LoRA represents the weight updates ∆W with two smaller matrices (called <em>update matrices</em>) through low-rank decomposition. These new matrices can be trained to adapt to the new data while keeping the overall number of parameters low. The original weight matrix remains frozen and doesn’t receive any further updates. To produce the final results, the original and extra adapted weights are combined. You could also merge the adapter weights with the base model to eliminate inference latency.",ce,y,et='<img src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/peft/lora_animated.gif"/>',ge,C,tt="This approach has a number of advantages:",we,R,at="<li>LoRA makes finetuning more efficient by drastically reducing the number of trainable parameters.</li> <li>The original pretrained weights are kept frozen, which means you can have multiple lightweight and portable LoRA models for various downstream tasks built on top of them.</li> <li>LoRA is orthogonal to other parameter-efficient methods and can be combined with many of them.</li> <li>Performance of models finetuned using LoRA is comparable to the performance of fully finetuned models.</li>",ve,P,it="In principle, LoRA can be applied to any subset of weight matrices in a neural network to reduce the number of trainable parameters. However, for simplicity and further parameter efficiency, LoRA is typically only applied to the attention blocks in Transformer models. The resulting number of trainable parameters in a LoRA model depends on the size of the update matrices, which is determined mainly by the rank <code>r</code> and the shape of the original weight matrix.",ye,b,nt='<img src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/peft/lora.png"/>',be,F,rt='<a href="https://hf.co/papers/2103.10385">Navigating Text-To-Image Customization: From LyCORIS Fine-Tuning to Model Evaluation</a>',Le,O,xe,z,ot='<a href="https://arxiv.org/abs/2402.07148" rel="nofollow">X-LoRA</a> is a mixture of experts method for LoRA which works by using dense or sparse gating to dynamically activate LoRA experts. The LoRA experts as well as the base model are frozen during training, resulting in a low parameter count as only the gating layers must be trained. In particular, the gating layers output scalings which (depending on config) are granular on the layer and token level. Additionally, during inference, X-LoRA dynamically activates LoRA adapters to recall knowledge and effectively mix them:',Te,E,lt='<img src="https://github.com/EricLBuehler/xlora/raw/master/res/token_by_token_scalings.gif" alt="Token-by-token scalings"/>',$e,j,st="For each step, X-LoRA requires the base model to be run twice: first, to get hidden states without any LoRA adapters, and secondly, the hidden states are used to calculate scalings which are applied to the LoRA adapters and the model is run a second time. The output of the second run is the result of the model step.",ke,I,pt="Ultimately, X-LoRA allows the model to reflect upon it’s knowledge because of the dual forward pass scheme, and dynamically reconfigure the architecture.",Ae,K,He,W,mt='Low-rank decomposition can impact performance because the weight updates are limited to the low-rank space, which can constrain a model’s expressiveness. However, you don’t necessarily want to use a larger rank because it increases the number of trainable parameters. To address this, <a href="https://huggingface.co/papers/2108.06098" rel="nofollow">LoHa</a> (a method originally developed for computer vision) was applied to diffusion models where the ability to generate diverse images is an important consideration. LoHa should also work with general model types, but the embedding layers aren’t currently implemented in PEFT.',_e,S,dt='LoHa uses the <a href="https://en.wikipedia.org/wiki/Hadamard_product_(matrices)" rel="nofollow">Hadamard product</a> (element-wise product) instead of the matrix product. ∆W is represented by four smaller matrices instead of two - like in LoRA - and each pair of these low-rank matrices are combined with the Hadamard product. As a result, ∆W can have the same number of trainable parameters but a higher rank and expressivity.',Me,B,Ce,D,ht='<a href="https://hf.co/papers/2309.14859" rel="nofollow">LoKr</a> is very similar to LoRA and LoHa, and it is also mainly applied to diffusion models, though you could also use it with other model types. LoKr replaces the matrix product with the <a href="https://en.wikipedia.org/wiki/Kronecker_product" rel="nofollow">Kronecker product</a> instead. The Kronecker product decomposition creates a block matrix which preserves the rank of the original weight matrix. Another benefit of the Kronecker product is that it can be vectorized by stacking the matrix columns. This can speed up the process because you’re avoiding fully reconstructing ∆W.',Re,V,Pe,L,ft='<img src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/peft/oft.png"/>',Fe,X,ut='<a href="https://hf.co/papers/2306.07280">Controlling Text-to-Image Diffusion by Orthogonal Finetuning</a>',Oe,q,ct='<a href="https://hf.co/papers/2306.07280" rel="nofollow">OFT</a> is a method that primarily focuses on preserving a pretrained model’s generative performance in the finetuned model. It tries to maintain the same cosine similarity (hyperspherical energy) between all pairwise neurons in a layer because this better captures the semantic information among neurons. This means OFT is more capable at preserving the subject and it is better for controllable generation (similar to <a href="https://huggingface.co/docs/diffusers/using-diffusers/controlnet" rel="nofollow">ControlNet</a>).',ze,N,gt="OFT preserves the hyperspherical energy by learning an orthogonal transformation for neurons to keep the cosine similarity between them unchanged. In practice, this means taking the matrix product of an orthogonal matrix with the pretrained weight matrix. However, to be parameter-efficient, the orthogonal matrix is represented as a block-diagonal matrix with rank <code>r</code> blocks. Whereas LoRA reduces the number of trainable parameters with low-rank structures, OFT reduces the number of trainable parameters with a sparse block-diagonal matrix structure.",Ee,U,je,G,wt='<a href="https://hf.co/papers/2311.06243" rel="nofollow">BOFT</a> is a method that primarily focuses on preserving a pretrained model’s generative performance in the finetuned model. It tries to maintain the same cosine similarity (hyperspherical energy) between all pairwise neurons in a layer because this better captures the semantic information among neurons. This means OFT is more capable at preserving the subject and it is better for controllable generation (similar to <a href="https://huggingface.co/docs/diffusers/using-diffusers/controlnet" rel="nofollow">ControlNet</a>).',Ie,Y,vt="OFT preserves the hyperspherical energy by learning an orthogonal transformation for neurons to keep the cosine similarity between them unchanged. In practice, this means taking the matrix product of an orthogonal matrix with the pretrained weight matrix. However, to be parameter-efficient, the orthogonal matrix is represented as a block-diagonal matrix with rank <code>r</code> blocks. Whereas LoRA reduces the number of trainable parameters with low-rank structures, OFT reduces the number of trainable parameters with a sparse block-diagonal matrix structure.",Ke,Z,We,J,yt='<a href="https://hf.co/papers/2303.10512" rel="nofollow">AdaLoRA</a> manages the parameter budget introduced from LoRA by allocating more parameters - in other words, a higher rank <code>r</code> - for important weight matrices that are better adapted for a task and pruning less important ones. The rank is controlled by a method similar to singular value decomposition (SVD). The ∆W is parameterized with two orthogonal matrices and a diagonal matrix which contains singular values. This parametrization method avoids iteratively applying SVD which is computationally expensive. Based on this method, the rank of ∆W is adjusted according to an importance score. ∆W is divided into triplets and each triplet is scored according to its contribution to model performance. Triplets with low importance scores are pruned and triplets with high importance scores are kept for finetuning.',Se,Q,Be,ee,bt='<a href="https://hf.co/papers/2303.16199" rel="nofollow">Llama-Adapter</a> is a method for adapting Llama into a instruction-following model. To help adapt the model for instruction-following, the adapter is trained with a 52K instruction-output dataset.',De,te,Lt="A set of of learnable adaption prompts are prefixed to the input instruction tokens. These are inserted into the upper layers of the model because it is better to learn with the higher-level semantics of the pretrained model. The instruction-output tokens prefixed to the input guide the adaption prompt to generate a contextual response.",Ve,x,xt='<img src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/peft/llama-adapter.png"/>',Xe,ae,Tt='<a href="https://hf.co/papers/2303.16199">LLaMA-Adapter: Efficient Fine-tuning of Language Models with Zero-init Attention</a>',qe,ie,$t="To avoid adding noise to the tokens, the adapter uses zero-initialized attention. On top of this, the adapter adds a learnable gating factor (initialized with zeros) to progressively add information to the model during training. This prevents overwhelming the model’s pretrained knowledge with the newly learned instructions.",Ne,ne,Ue,le,Ge;return $=new w({props:{title:"Adapters",local:"adapters",headingTag:"h1"}}),H=new w({props:{title:"Low-Rank Adaptation (LoRA)",local:"low-rank-adaptation-lora",headingTag:"h2"}}),v=new Ot({props:{$$slots:{default:[Et]},$$scope:{ctx:se}}}),O=new w({props:{title:"Mixture of LoRA Experts (X-LoRA)",local:"mixture-of-lora-experts-x-lora",headingTag:"h2"}}),K=new w({props:{title:"Low-Rank Hadamard Product (LoHa)",local:"low-rank-hadamard-product-loha",headingTag:"h2"}}),B=new w({props:{title:"Low-Rank Kronecker Product (LoKr)",local:"low-rank-kronecker-product-lokr",headingTag:"h2"}}),V=new w({props:{title:"Orthogonal Finetuning (OFT)",local:"orthogonal-finetuning-oft",headingTag:"h2"}}),U=new w({props:{title:"Orthogonal Butterfly (BOFT)",local:"orthogonal-butterfly-boft",headingTag:"h2"}}),Z=new w({props:{title:"Adaptive Low-Rank Adaptation (AdaLoRA)",local:"adaptive-low-rank-adaptation-adalora",headingTag:"h2"}}),Q=new w({props:{title:"Llama-Adapter",local:"llama-adapter",headingTag:"h2"}}),ne=new zt({props:{source:"https://github.com/huggingface/peft/blob/main/docs/source/conceptual_guides/adapter.md"}}),{c(){p=o("meta"),T=n(),m=o("p"),re=n(),d($.$$.fragment),pe=n(),k=o("p"),k.textContent=Ye,me=n(),A=o("p"),A.textContent=Ze,de=n(),d(H.$$.fragment),he=n(),d(v.$$.fragment),fe=n(),_=o("p"),_.innerHTML=Je,ue=n(),M=o("p"),M.innerHTML=Qe,ce=n(),y=o("div"),y.innerHTML=et,ge=n(),C=o("p"),C.textContent=tt,we=n(),R=o("ul"),R.innerHTML=at,ve=n(),P=o("p"),P.innerHTML=it,ye=n(),b=o("div"),b.innerHTML=nt,be=n(),F=o("small"),F.innerHTML=rt,Le=n(),d(O.$$.fragment),xe=n(),z=o("p"),z.innerHTML=ot,Te=n(),E=o("p"),E.innerHTML=lt,$e=n(),j=o("p"),j.textContent=st,ke=n(),I=o("p"),I.textContent=pt,Ae=n(),d(K.$$.fragment),He=n(),W=o("p"),W.innerHTML=mt,_e=n(),S=o("p"),S.innerHTML=dt,Me=n(),d(B.$$.fragment),Ce=n(),D=o("p"),D.innerHTML=ht,Re=n(),d(V.$$.fragment),Pe=n(),L=o("div"),L.innerHTML=ft,Fe=n(),X=o("small"),X.innerHTML=ut,Oe=n(),q=o("p"),q.innerHTML=ct,ze=n(),N=o("p"),N.innerHTML=gt,Ee=n(),d(U.$$.fragment),je=n(),G=o("p"),G.innerHTML=wt,Ie=n(),Y=o("p"),Y.innerHTML=vt,Ke=n(),d(Z.$$.fragment),We=n(),J=o("p"),J.innerHTML=yt,Se=n(),d(Q.$$.fragment),Be=n(),ee=o("p"),ee.innerHTML=bt,De=n(),te=o("p"),te.textContent=Lt,Ve=n(),x=o("div"),x.innerHTML=xt,Xe=n(),ae=o("small"),ae.innerHTML=Tt,qe=n(),ie=o("p"),ie.textContent=$t,Ne=n(),d(ne.$$.fragment),Ue=n(),le=o("p"),this.h()},l(e){const t=Pt("svelte-u9bgzb",document.head);p=l(t,"META",{name:!0,content:!0}),t.forEach(a),T=r(e),m=l(e,"P",{}),At(m).forEach(a),re=r(e),h($.$$.fragment,e),pe=r(e),k=l(e,"P",{"data-svelte-h":!0}),s(k)!=="svelte-1udysl8"&&(k.textContent=Ye),me=r(e),A=l(e,"P",{"data-svelte-h":!0}),s(A)!=="svelte-2ih5z0"&&(A.textContent=Ze),de=r(e),h(H.$$.fragment,e),he=r(e),h(v.$$.fragment,e),fe=r(e),_=l(e,"P",{"data-svelte-h":!0}),s(_)!=="svelte-1jx2sye"&&(_.innerHTML=Je),ue=r(e),M=l(e,"P",{"data-svelte-h":!0}),s(M)!=="svelte-1h9l7gl"&&(M.innerHTML=Qe),ce=r(e),y=l(e,"DIV",{class:!0,"data-svelte-h":!0}),s(y)!=="svelte-1yiq52m"&&(y.innerHTML=et),ge=r(e),C=l(e,"P",{"data-svelte-h":!0}),s(C)!=="svelte-tt8pol"&&(C.textContent=tt),we=r(e),R=l(e,"UL",{"data-svelte-h":!0}),s(R)!=="svelte-18hcxvt"&&(R.innerHTML=at),ve=r(e),P=l(e,"P",{"data-svelte-h":!0}),s(P)!=="svelte-j2a6td"&&(P.innerHTML=it),ye=r(e),b=l(e,"DIV",{class:!0,"data-svelte-h":!0}),s(b)!=="svelte-oil2ou"&&(b.innerHTML=nt),be=r(e),F=l(e,"SMALL",{"data-svelte-h":!0}),s(F)!=="svelte-1py15yj"&&(F.innerHTML=rt),Le=r(e),h(O.$$.fragment,e),xe=r(e),z=l(e,"P",{"data-svelte-h":!0}),s(z)!=="svelte-1eypcy0"&&(z.innerHTML=ot),Te=r(e),E=l(e,"P",{"data-svelte-h":!0}),s(E)!=="svelte-bww8jk"&&(E.innerHTML=lt),$e=r(e),j=l(e,"P",{"data-svelte-h":!0}),s(j)!=="svelte-rgrq61"&&(j.textContent=st),ke=r(e),I=l(e,"P",{"data-svelte-h":!0}),s(I)!=="svelte-y2arhg"&&(I.textContent=pt),Ae=r(e),h(K.$$.fragment,e),He=r(e),W=l(e,"P",{"data-svelte-h":!0}),s(W)!=="svelte-26ytw"&&(W.innerHTML=mt),_e=r(e),S=l(e,"P",{"data-svelte-h":!0}),s(S)!=="svelte-2t2yyu"&&(S.innerHTML=dt),Me=r(e),h(B.$$.fragment,e),Ce=r(e),D=l(e,"P",{"data-svelte-h":!0}),s(D)!=="svelte-kr8vx3"&&(D.innerHTML=ht),Re=r(e),h(V.$$.fragment,e),Pe=r(e),L=l(e,"DIV",{class:!0,"data-svelte-h":!0}),s(L)!=="svelte-yxp5w7"&&(L.innerHTML=ft),Fe=r(e),X=l(e,"SMALL",{"data-svelte-h":!0}),s(X)!=="svelte-1bvbr61"&&(X.innerHTML=ut),Oe=r(e),q=l(e,"P",{"data-svelte-h":!0}),s(q)!=="svelte-11bv21u"&&(q.innerHTML=ct),ze=r(e),N=l(e,"P",{"data-svelte-h":!0}),s(N)!=="svelte-1pykz3m"&&(N.innerHTML=gt),Ee=r(e),h(U.$$.fragment,e),je=r(e),G=l(e,"P",{"data-svelte-h":!0}),s(G)!=="svelte-yhpvua"&&(G.innerHTML=wt),Ie=r(e),Y=l(e,"P",{"data-svelte-h":!0}),s(Y)!=="svelte-1pykz3m"&&(Y.innerHTML=vt),Ke=r(e),h(Z.$$.fragment,e),We=r(e),J=l(e,"P",{"data-svelte-h":!0}),s(J)!=="svelte-1343mpt"&&(J.innerHTML=yt),Se=r(e),h(Q.$$.fragment,e),Be=r(e),ee=l(e,"P",{"data-svelte-h":!0}),s(ee)!=="svelte-1hcky1l"&&(ee.innerHTML=bt),De=r(e),te=l(e,"P",{"data-svelte-h":!0}),s(te)!=="svelte-7sjbf9"&&(te.textContent=Lt),Ve=r(e),x=l(e,"DIV",{class:!0,"data-svelte-h":!0}),s(x)!=="svelte-3f0tu3"&&(x.innerHTML=xt),Xe=r(e),ae=l(e,"SMALL",{"data-svelte-h":!0}),s(ae)!=="svelte-1npun8x"&&(ae.innerHTML=Tt),qe=r(e),ie=l(e,"P",{"data-svelte-h":!0}),s(ie)!=="svelte-8urzuj"&&(ie.textContent=$t),Ne=r(e),h(ne.$$.fragment,e),Ue=r(e),le=l(e,"P",{}),At(le).forEach(a),this.h()},h(){oe(p,"name","hf:doc:metadata"),oe(p,"content",It),oe(y,"class","flex justify-center"),oe(b,"class","flex justify-center"),oe(L,"class","flex justify-center"),oe(x,"class","flex justify-center")},m(e,t){Ft(document.head,p),i(e,T,t),i(e,m,t),i(e,re,t),f($,e,t),i(e,pe,t),i(e,k,t),i(e,me,t),i(e,A,t),i(e,de,t),f(H,e,t),i(e,he,t),f(v,e,t),i(e,fe,t),i(e,_,t),i(e,ue,t),i(e,M,t),i(e,ce,t),i(e,y,t),i(e,ge,t),i(e,C,t),i(e,we,t),i(e,R,t),i(e,ve,t),i(e,P,t),i(e,ye,t),i(e,b,t),i(e,be,t),i(e,F,t),i(e,Le,t),f(O,e,t),i(e,xe,t),i(e,z,t),i(e,Te,t),i(e,E,t),i(e,$e,t),i(e,j,t),i(e,ke,t),i(e,I,t),i(e,Ae,t),f(K,e,t),i(e,He,t),i(e,W,t),i(e,_e,t),i(e,S,t),i(e,Me,t),f(B,e,t),i(e,Ce,t),i(e,D,t),i(e,Re,t),f(V,e,t),i(e,Pe,t),i(e,L,t),i(e,Fe,t),i(e,X,t),i(e,Oe,t),i(e,q,t),i(e,ze,t),i(e,N,t),i(e,Ee,t),f(U,e,t),i(e,je,t),i(e,G,t),i(e,Ie,t),i(e,Y,t),i(e,Ke,t),f(Z,e,t),i(e,We,t),i(e,J,t),i(e,Se,t),f(Q,e,t),i(e,Be,t),i(e,ee,t),i(e,De,t),i(e,te,t),i(e,Ve,t),i(e,x,t),i(e,Xe,t),i(e,ae,t),i(e,qe,t),i(e,ie,t),i(e,Ne,t),f(ne,e,t),i(e,Ue,t),i(e,le,t),Ge=!0},p(e,[t]){const kt={};t&2&&(kt.$$scope={dirty:t,ctx:e}),v.$set(kt)},i(e){Ge||(u($.$$.fragment,e),u(H.$$.fragment,e),u(v.$$.fragment,e),u(O.$$.fragment,e),u(K.$$.fragment,e),u(B.$$.fragment,e),u(V.$$.fragment,e),u(U.$$.fragment,e),u(Z.$$.fragment,e),u(Q.$$.fragment,e),u(ne.$$.fragment,e),Ge=!0)},o(e){c($.$$.fragment,e),c(H.$$.fragment,e),c(v.$$.fragment,e),c(O.$$.fragment,e),c(K.$$.fragment,e),c(B.$$.fragment,e),c(V.$$.fragment,e),c(U.$$.fragment,e),c(Z.$$.fragment,e),c(Q.$$.fragment,e),c(ne.$$.fragment,e),Ge=!1},d(e){e&&(a(T),a(m),a(re),a(pe),a(k),a(me),a(A),a(de),a(he),a(fe),a(_),a(ue),a(M),a(ce),a(y),a(ge),a(C),a(we),a(R),a(ve),a(P),a(ye),a(b),a(be),a(F),a(Le),a(xe),a(z),a(Te),a(E),a($e),a(j),a(ke),a(I),a(Ae),a(He),a(W),a(_e),a(S),a(Me),a(Ce),a(D),a(Re),a(Pe),a(L),a(Fe),a(X),a(Oe),a(q),a(ze),a(N),a(Ee),a(je),a(G),a(Ie),a(Y),a(Ke),a(We),a(J),a(Se),a(Be),a(ee),a(De),a(te),a(Ve),a(x),a(Xe),a(ae),a(qe),a(ie),a(Ne),a(Ue),a(le)),a(p),g($,e),g(H,e),g(v,e),g(O,e),g(K,e),g(B,e),g(V,e),g(U,e),g(Z,e),g(Q,e),g(ne,e)}}}const It='{"title":"Adapters","local":"adapters","sections":[{"title":"Low-Rank Adaptation (LoRA)","local":"low-rank-adaptation-lora","sections":[],"depth":2},{"title":"Mixture of LoRA Experts (X-LoRA)","local":"mixture-of-lora-experts-x-lora","sections":[],"depth":2},{"title":"Low-Rank Hadamard Product (LoHa)","local":"low-rank-hadamard-product-loha","sections":[],"depth":2},{"title":"Low-Rank Kronecker Product (LoKr)","local":"low-rank-kronecker-product-lokr","sections":[],"depth":2},{"title":"Orthogonal Finetuning (OFT)","local":"orthogonal-finetuning-oft","sections":[],"depth":2},{"title":"Orthogonal Butterfly (BOFT)","local":"orthogonal-butterfly-boft","sections":[],"depth":2},{"title":"Adaptive Low-Rank Adaptation (AdaLoRA)","local":"adaptive-low-rank-adaptation-adalora","sections":[],"depth":2},{"title":"Llama-Adapter","local":"llama-adapter","sections":[],"depth":2}],"depth":1}';function Kt(se){return _t(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Vt extends Ct{constructor(p){super(),Rt(this,p,Kt,jt,Ht,{})}}export{Vt as component};
